-- fog.lua - a fog effect

fog = love.graphics.newPixelEffect [[
	extern number fog_x;
	extern number fog_y;
	vec4 effect(vec4 color, Image texture, vec2 tc, vec2 pixel_coords)
	{
	vec4 pixel = Texel( texture, tc );
	float root = sqrt((fog_x-tc.x)*(fog_x-tc.x)+(fog_y-tc.y)*(fog_y-tc.y));
	float posx = sign(fog_x-tc.x);
	float posy = sign(fog_y-tc.y);
	{pixel.r = pixel.r-(posx*(fog_x-tc.x)+posy*(fog_y-tc.y));}
	{pixel.g = pixel.g-(posx*(fog_x-tc.x)+posy*(fog_y-tc.y));}
	{pixel.b = pixel.b-(posx*(fog_x-tc.x)+posy*(fog_y-tc.y));}
	{pixel.a = 1-root/10;}	// fog out edges of image
	return  pixel;
	}
	]]
