-- god.lua - god_ray effect

--[[
	Mandarancio suggests:
	decay (~0.5-0.8)
	density (~0.2-0.4)
	weight (~0.5-2)
	]]

god = love.graphics.newPixelEffect [[
		extern number decay;
		extern number density;
		extern number weight;
		extern vec2 ltgDir;
		extern number numSamp;
		//uniform sampler2D firstPass;

		vec4 effect(vec4 color, Image texture, vec2 texture_coords, vec2 pixel_coords)
		{
		vec2 deltaTextCoord = texture_coords - ltgDir;
		deltaTextCoord *= 1.0 / float(numSamp) * density;
		number illuminationDecay = 1.0;
		vec2 textCoo=texture_coords;
		vec4 result=texture2D(texture, textCoo );
		for(int i=0; i < numSamp ; i++)
			{
			textCoo -= deltaTextCoord;
			vec4 sample = texture2D(texture, textCoo );
			sample *= illuminationDecay * weight;
			result += sample/numSamp;
			illuminationDecay *= decay;
			}
		return result;
		}
		]]
