-- main.lua  for god_ray.love

require 'colors'
require 'shortcuts'
require "god"
require "fog"
help = require 'help'

function love.load()
	help.load()
	love.graphics.setBackgroundColor( 255,255,255 )
	g_ray = {
		decay	= 1.08,
		density	= 0.5,
		weight	= 0.5,
		ltgDir	= { 0.8, 0.5 },
		numSamp = 20
		}
	f_set = {
		fog_x = 0.7,
		fog_y = 0.5
		}
	for i,j in pairs(g_ray) do god:send(i,j) end
	for i,j in pairs(f_set) do fog:send(i,j) end
	img		= gr.newImage( "London.jpg" )
	show 	= {
		god		= true,
		fog		= true,
		help	= true
		}
	canvas1 = love.graphics.newCanvas()
	canvas2 = love.graphics.newCanvas()
	canvas3 = love.graphics.newCanvas()
	updateEffects()
	end

function love.update( dt )
	end

function love.draw()
	gr.draw(canvas3)
	help.draw()
	end

function love.keypressed( key )
	if key == 'escape'	then love.event.push('quit')			end
	if key == 'f'		then show.fog		= not show.fog		end
	if key == 'g'		then show.god		= not show.god 		end
	if key == 'h'		then show.help      = not show.help 	end
	if key == 'right'	then g_ray.ltgDir[1]= g_ray.ltgDir[1]-.1 god:send('ltgDir',  g_ray.ltgDir)	end
	if key == 'left'	then g_ray.ltgDir[1]= g_ray.ltgDir[1]+.1 god:send('ltgDir',  g_ray.ltgDir)	end
	if key == 'up'		then g_ray.ltgDir[2]= g_ray.ltgDir[2]-.1 god:send('ltgDir',  g_ray.ltgDir)	end
	if key == 'down'	then g_ray.ltgDir[2]= g_ray.ltgDir[2]+.1 god:send('ltgDir',  g_ray.ltgDir)	end
	if key == 'n'		then g_ray.numSamp  = g_ray.numSamp - 1  god:send('numSamp', g_ray.numSamp)	end
	if key == 'm'		then g_ray.numSamp  = g_ray.numSamp + 1  god:send('numSamp', g_ray.numSamp)	end
	if key == 'j'		then f_set.fog_x    = f_set.fog_x - 0.1  fog:send('fog_x',	 f_set.fog_x)	end
	if key == 'l'		then f_set.fog_x    = f_set.fog_x + 0.1  fog:send('fog_x',	 f_set.fog_x)	end
	if key == 'k'		then f_set.fog_y    = f_set.fog_y - 0.1  fog:send('fog_y',	 f_set.fog_y)	end
	if key == 'i'		then f_set.fog_y    = f_set.fog_y + 0.1  fog:send('fog_y',	 f_set.fog_y)	end
	if key == 'a'		then g_ray.density	= g_ray.density - .005 god:send('density',g_ray.density) end
	if key == 's'		then g_ray.density	= g_ray.density + .005 god:send('density',g_ray.density) end
	if key == 'w'		then g_ray.weight 	= g_ray.weight  + .005 god:send('weight', g_ray.weight)	end
	if key == 'q'		then g_ray.weight 	= g_ray.weight  - .005 god:send('weight', g_ray.weight)	end
	if key == 'x'		then g_ray.decay	= g_ray.decay   + .005 god:send('decay',  g_ray.decay)	end
	if key == 'z'		then g_ray.decay	= g_ray.decay   - .005 god:send('decay',  g_ray.decay)	end
	updateEffects()
	end

function updateEffects()
	copyCanvas( img, canvas1 )			-- img > canvas1
	if show.fog then					-- canvas1 > canvas2 (fogged)
		addEffect( fog, canvas1, canvas2 )
		else
		copyCanvas(canvas1,canvas2)		-- or canvas1 > canvas (unmodified
		end
	if show.god then					-- canvas2 > canvas3 (god applied)
		addEffect(god,canvas2,canvas3)
		gr.setCanvas( canvas3 )			-- add parameter setting display
		gr.print("density: "..g_ray.density,10,25)
		gr.print("weight:  "..g_ray.weight,10,10)
		gr.print("decay:   "..g_ray.decay,10,40)
		gr.print("light X: "..g_ray.ltgDir[1],100,10)
		gr.print("light Y: "..g_ray.ltgDir[2],100,25)
		gr.print("numSamp: "..g_ray.numSamp,100,40)
		if show.fog then
			gr.print("fog X: "..f_set.fog_x,200,10)
			gr.print("fog Y: "..f_set.fog_y,200,25)
			end
		gr.setCanvas()
		else							-- or canvas2 > canvas3 (unmodified)
		copyCanvas(canvas2,canvas3)
		end
	end

function addEffect( effect, sourceCanvas, destCanvas )
	gr.setPixelEffect( effect )
	destCanvas:clear()
	gr.setCanvas( destCanvas )
	gr.draw( sourceCanvas )
	gr.setCanvas()
	gr.setPixelEffect()
	end

function copyCanvas( sourceCanvas, destCanvas )
	gr.setCanvas( destCanvas )
	gr.draw( sourceCanvas )
	gr.setCanvas()
	end
